unit Mainunit;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, DB, Win95gau, DBTables, Dialogs, FileCtrl;

{$define english}

const
  Version = '1.0';

{$ifdef english}
  BestaetigungStr       = 'Are you sure, to start this tool?';
  ProtokollKopf1        = 'Referential-Integrity-Check on Database %s (Date: %s)';
  ProtokollKopf2        = 'Table'+#9+'Field'+#9+'Value'+#9+'RecNum'+#9+'MasterTable'+#9+'MasterField';
  EinenMoment           = 'one moment please ...';
  FehlerGefunden        = 'While checkin the referentiel integrity, %d errors were found. '+
                          'Please check the log-file %s.';
  KeineFehlerGefunden   = 'There was no error found in this database.';
  UnbekannterAbbruch    = 'There was an unexpected error.';
  NurEinFeldBeiRefInt   = 'In this version, only Ref.Int. on one field can be checked.';
  Abbruch               = 'Cancel';
  Protokolldatei        = 'Log-File';
  DatenbankAlias        = 'Database-Alias';
  RefIntUeberpruefen    = 'Check Referential Integrity';
  InfoLine0             = 'This tool check the referential integrity on the';
  InfoLine1             = 'database, specified in the combobox';
  InfoLine2             = 'The result is written in the log-file';
{$else}
  BestaetigungStr       = 'Sind Sie sicher, da das Hilfsprogramm ausgefhrt werden soll?';
  ProtokollKopf1        = 'Referentielle Integritt der Datenbank %s untersuchen (Datum: %s)';
  ProtokollKopf2        = 'Tabelle'+#9+'Feld'+#9+'Wert'+#9+'RecNum'+#9+'MasterTabelle'+#9+'MasterFeld';
  EinenMoment           = 'einen Moment bitte ...';
  FehlerGefunden        = 'Beim berprfen der referentiellen Integritt konnten %d Fehler festgestellt werden. '+
                          'Bitte berprfen Sie die Protokolldatei %s';
  KeineFehlerGefunden   = 'Es konnten keine Fehler festgestellt werden.';
  UnbekannterAbbruch    = 'Das Hilfsprogramm konnte nicht korrekt durchgefhrt werden.';
  NurEinFeldBeiRefInt   = 'In dieser Version knnen nur Ref.Int. auf einem Feld berprft werden.';
  Abbruch               = 'Abbruch';
  Protokolldatei        = 'Protokolldatei';
  DatenbankAlias        = 'Datenbank-Alias';
  RefIntUeberpruefen    = 'Referentielle Integritt berprfen';
  InfoLine0             = 'Dieses Hilfsprogramm berprft die referentielle Integritt der';
  InfoLine1             = 'NOS-Datenbank.';
  InfoLine2             = 'Die Ergebnisse werden in der Protokolldatei ausgegeben.';
{$endif}


type TMyItem = class(TObject)
     public
       theTable : TTable;
       theFieldName : string;
     end;

type
  TFormHilfsprogramm = class(TForm)
    PanelButton: TPanel;
    BitBtnOk: TBitBtn;
    BitBtnAbbruch: TBitBtn;
    MemoErklaerung: TMemo;
    Win95Gauge: TWin95Gauge;
    TableSource: TTable;
    LabelLogDatei: TLabel;
    EditLogFile: TEdit;
    ButtonFileSave: TButton;
    SaveDialog1: TSaveDialog;
    FileListBox1: TFileListBox;
    ComboBoxAlias: TComboBox;
    Label1: TLabel;
    DirectoryListBox1: TDirectoryListBox;
    procedure FormCreate(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure BitBtnAbbruchClick(Sender: TObject);
    procedure ButtonFileSaveClick(Sender: TObject);
    procedure ComboBoxAliasChange(Sender: TObject);
  private
    { Private declarations }
    FieldnameSource1,
    FieldnameSource2,
    FieldnameSource3,
    FieldnameSource4,
    FieldnameSource5 : string;
    txt : TextFile;
    MyMasterList : TList;

    RefIntFehler : integer;

    TheAlias : string;

    procedure CheckThisRefInt(aTableSource : TTable; aDataNr : longint;
                              aTableMaster : TTable; aFieldnameSource : string);
    procedure CheckRefInt;

    procedure ErmittleRefIntWerte(const aTableName : string);

    procedure Protokolliere(aString : string);

  public
    { Public declarations }
  end;

var FormHilfsprogramm : TFormHilfsprogramm;

implementation

uses
     NosConst,
     NosGlobl,
     SysUtils,
     DbiProcs,
     DbiTypes,
     DbiErrs,
     MyTools;

{$R *.DFM}

procedure TFormHilfsprogramm.FormCreate(Sender: TObject);
var i : integer;
begin
  TheAlias := '';
  for i:=1 to ParamCount do
    if Uppercase(copy(ParamStr(i),1,6)) = 'ALIAS='
    then begin
      TheAlias := copy(ParamStr(i),7,255);
      break;
    end
    else
    if Uppercase(copy(ParamStr(i),1,7)) = '/ALIAS='
    then begin
      TheAlias := copy(ParamStr(i),8,255);
      break;
    end;

  Session.GetDataBaseNames(ComboBoxAlias.Items);
  for i := 0 to ComboBoxAlias.Items.Count-1
  do if ComboBoxAlias.Items[i] = TheAlias then ComboBoxAlias.ItemIndex := i;

  BitBtnAbbruch.Caption := Abbruch;
  LabelLogDatei.Caption := Protokolldatei;
  Label1.Caption := DatenbankAlias;
  Caption := RefIntUeberpruefen+' Version '+Version;
  MemoErklaerung.Lines[0] := InfoLine0;
  MemoErklaerung.Lines[1] := InfoLine1;
  MemoErklaerung.Lines[2] := InfoLine2;

end;

procedure TFormHilfsprogramm.Protokolliere(aString : string);
begin
  append(txt);
  writeln(txt, astring);
  closefile(txt);
end;

procedure TFormHilfsprogramm.BitBtnOkClick(Sender: TObject);
var AltHeight           : integer;
    AltCaption          : string;
    AllesOk             : boolean;
    i                   : integer;
begin
  if not Bestaetigen(BestaetigungStr,0) then exit;

  assignfile(txt, EditLogFile.Text);
  if not fileexists(EditLogFile.Text) then rewrite(txt)
  else append(txt);
  writeln(txt);
  writeln(txt, Format(ProtokollKopf1, [DirectoryListBox1.Directory, DateTimeToStr(Now)]));
{  'Referentielle Integritt untersuchen ('+DateTimeToStr(Now)+')');}
  writeln(txt);
  writeln(txt, ProtokollKopf2);
{  'Tabelle'+#9+'Feld'+#9+'Wert'+#9+'RecNum'+#9+'MasterTabelle'+#9+'MasterFeld');}
  writeln(txt, '------------------------------------------------------------------------');
  writeln(txt);
  closefile(txt);

  RefIntFehler := 0;

  AllesOk := false;

  AltHeight := Height;
  AltCaption := Caption;
  try
    Caption := EinenMoment;
    Height := 68;

    Screen.Cursor := crHourglass;

    PanelButton.Visible := false;
    MemoErklaerung.Visible := false;
    Win95Gauge.Visible := true;

    FileListBox1.Directory := DirectoryListBox1.Directory;

    Win95Gauge.Progress := 0;
    Win95Gauge.MaxValue := FileListBox1.Items.Count;

    KeepWindowsAlive;

    for i := 0 to FileListBox1.Items.Count-1
    do begin
      Win95Gauge.Progress := i;
      ErmittleRefIntWerte(FileListBox1.Items[i]);
    end;

    Win95Gauge.Progress := Win95Gauge.MaxValue;

    AllesOk := true;
  finally
    Screen.Cursor := crDefault;

    PanelButton.Visible := true;
    MemoErklaerung.Visible := true;
    Win95Gauge.Visible := false;

    Height := AltHeight;
    Caption := AltCaption;
  end;

  if AllesOk
  then begin
    if RefIntFehler > 0 then
      Fehler(Format(FehlerGefunden{'Beim berprfen der referentiellen Integritt konnten %d Fehler festgestellt werden. '+
                    'Bitte berprfen Sie die Protokolldatei %s'},
                    [RefIntFehler, EditLogFile.Text]) ,0)
    else Hinweis(KeineFehlerGefunden{'Es konnten keine Fehler festgestellt werden.'},0);
  end
  else Fehler(UnbekannterAbbruch{'Das Hilfsprogramm konnte nicht korrekt durchgefhrt werden.'},0);
  Close;
end;

procedure TFormHilfsprogramm.CheckThisRefInt(aTableSource : TTable; aDataNr : longint;
                                             aTableMaster : TTable; aFieldnameSource : string);
begin
  if aTableSource.FieldByName(aFieldnameSource).AsString <> ''
  then begin
    if not aTableMaster.FindKey([aTableSource.FieldByName(aFieldnameSource).AsInteger])
    then begin
      Protokolliere(WithoutExtension(aTableSource.TableName)+#9+aFieldnameSource+#9+
                         aTableSource.FieldByName(aFieldnameSource).AsString+#9+IntToStr(aDataNr)+#9+
                    WithoutExtension(aTableMaster.TableName)+#9+aTableMaster.Fields[0].FieldName);
      inc(RefIntFehler);
    end;
  end;
end;

procedure TFormHilfsprogramm.CheckRefInt;
var DataNr : longint;
    i : integer;
    aMyItem : TMyItem;
begin
  Win95Gauge.Progress := Win95Gauge.Progress+1;

  KeepWindowsAlive;
  TableSource.Open;

  for i := 0 to MyMasterList.Count-1
  do begin
    aMyItem := TMyItem(MyMasterList.Items[i]);
    aMyItem.TheTable.Open;
  end;

  KeepWindowsAlive;

  DataNr := 0;
  while not TableSource.eof
  do begin
    inc(DataNr);
    for i := 0 to MyMasterList.Count-1
    do begin
      aMyItem := TMyItem(MyMasterList.Items[i]);
      CheckThisRefInt(TableSource, DataNr, aMyItem.TheTable, aMyItem.TheFieldName);
    end;

    TableSource.Next;
  end;
  KeepWindowsAlive;

  for i := 0 to MyMasterList.Count-1
  do begin
    aMyItem := TMyItem(MyMasterList.Items[i]);
    aMyItem.TheTable.Close;
  end;

  TableSource.Close;
  KeepWindowsAlive;
end;

procedure TFormHilfsprogramm.ErmittleRefIntWerte(const aTableName : string);
var hChkCur    : hDBICur;
    aResult    : longint;
    aprintDesc : pRINTDesc;
    aRintNum   : integer;
    HilfStr    : string;
    i,j        : integer;
    aTableMaster : TTable;
    aMyItem : TMyItem;
begin
  TableSource.TableName := FileListBox1.Directory+'\'+aTableName;
  TableSource.Open;

  MyMasterList := TList.Create;

  aRintNum := 1;
  new(aprintDesc);
  while DbiGetRintDesc (TableSource.Handle, aRintNum, aprintDesc) = DBIERR_NONE
  do begin
    with aprintDesc^
    do begin
      if eType = rintDEPENDENT
      then begin
        if iFldCount > 1
        then begin
          Fehler(NurEinFeldBeiRefInt{'In dieser Version knnen nur Ref.Int. auf einem Feld berprft werden.'},0);
          exit;
        end;

        HilfStr := '';
        j := 0;
        while szTblName[j] <> #0
        do begin
          HilfStr := HilfStr + szTblName[j];
          inc(j);
        end;

        HilfStr := ExtractFileName(HilfStr);

        aMyItem := TMyItem.Create;

        with aMyItem
        do begin
          theTable := TTable.Create(nil);
          theTable.TableName := FileListBox1.Directory+'\'+HilfStr;

          theFieldName := TableSource.Fields[aiThisTabFld[0]-1].FieldName;
        end;

        MyMasterList.Add(aMyItem);

      end;
    end;
    inc(aRintNum);
  end;
  TableSource.Close;
  dispose(aprintDesc);

  CheckRefInt;

  for i := 0 to MyMasterList.Count-1
  do begin
    aMyItem := TMyItem(MyMasterList.Items[i]);
    aMyItem.Free;
  end;
  MyMasterList.Free;

end;

procedure TFormHilfsprogramm.BitBtnAbbruchClick(Sender: TObject);
begin
  Close;
end;

procedure TFormHilfsprogramm.ButtonFileSaveClick(Sender: TObject);
begin
  SaveDialog1.FileName := EditLogFile.Text;
  if SaveDialog1.Execute then EditLogFile.Text := SaveDialog1.FileName;
end;

procedure TFormHilfsprogramm.ComboBoxAliasChange(Sender: TObject);
begin
  TheAlias := ComboBoxAlias.Items[ComboboxAlias.ItemIndex];
  DirectoryListBox1.Directory := GetAliasPath(TheAlias);
end;

end.
